use Test::More tests => 7;
use strict;
use DE_EPAGES::Core::API::PerlTools qw( Memoize );

sub fib {
    my $n = shift;
    return $n if $n < 2;
    fib($n-1) + fib($n-2);
}

is( fib(30), 832040, "original function" );

*_fib = Memoize( \&fib );
is( _fib(30), 832040, "memoized named function, first time" );
is( _fib(30), 832040, "memoized named function, second time" );
is( _fib(30), 832040, "memoized named function, third time" );

my $FastFib = Memoize( sub {
    my $n = shift;
    return $n if $n < 2;
    fib($n-1) + fib($n-2);
});

is( $FastFib->(30), 832040, "memoized anonymous function, first time" );
is( $FastFib->(30), 832040, "memoized anonymous function, second time" );
is( $FastFib->(30), 832040, "memoized anonymous function, third time" );
