define(['testsuite/qunit', 'jquery', 'ep/ui/datatable', '$ready!'], function (QUnit, $, ep) {

    var resultData = {
            "tableHead": [{
                "isSortable": 0,
                "name": "",
                "id": "ObjectID",
                "isSelectable": 1
            }, {
                "isSortable": 1,
                "name": "Product number",
                "id": "Alias",
                "isSelectable": 0
            }, {
                "isSortable": 1,
                "name": "",
                "id": "NameOrAlias",
                "isSelectable": 0
            }, {
                "isSortable": 1,
                "name": "List price",
                "id": "ListPrice",
                "isSelectable": 0
            }],
            "totalNumber": "88",
            "orderBy": "NameOrAlias",
            "lastPage": 9,
            "orderDesc": null,
            "tableContent": {
                "1": [{
                    "Alias": "be_40401",
                    "ObjectID": 17151,
                    "VariationAttr": null,
                    "NameOrAlias": "Berghaus Paclite Jacket - Men",
                    "hasSubTable": 1,
                    "ListPrice": "199.95 €"
                }, {
                    "Alias": "be_40401[1]",
                    "ObjectID": 17429,
                    "VariationAttr": null,
                    "NameOrAlias": "Berghaus Paclite Jacket - Men",
                    "hasSubTable": 1,
                    "ListPrice": "199.95 €"
                }],
                "2": [{
                    "Alias": "be_40401",
                    "ObjectID": 17151,
                    "VariationAttr": null,
                    "NameOrAlias": "Berghaus Paclite Jacket - Men",
                    "hasSubTable": 1,
                    "ListPrice": "199.95 €"
                }]
            }
        };

    ep.ajax = function (o) {
        var result = $.Deferred();

        if (o.data) {
            if (o.data.ViewAction === 'JSONSearchProductsToInsert') {
                result.resolve(resultData);
            }
        }

        return result;
    };

    QUnit.module('ep/ui/datatable', {
        setup: function () {
            $('table').uiDatatable({
                action: 'JSONSearchProductsToInsert'
            });
        },
        teardown: function () {
            $('table').uiDatatable('destroy');

            QUnit.strictEqual(
                $('.ep-uiDatatable').length,
                0,
                'Class *ep-uiDatatable* was removed'
            );
        }
    });

    QUnit.test('Check datatables methods', function () {
        $.each(['_create', 'destroy'], function (i, method) {
            QUnit.strictEqual(
                $.isFunction($.ui.uiDatatable.prototype[method]),
                true,
                '$.isFunction(' + method + '):'
            );
        });
    });

    QUnit.test('Check datatables DOM structure', function () {
        QUnit.strictEqual(
            $('.ep-uiDatatable').length,
            1,
            'Class *ep-uiDatatable* was added'
        );

        QUnit.strictEqual(
            $('tbody tr').length,
            2,
            'Table contains two rows on page 1'
        );

        $('th input[name="ObjectID"]').trigger('click');

        QUnit.strictEqual(
            $('tbody input[name="ObjectID"]:checked').length,
            2,
            'All rows were selected'
        );

        $('a[data-page="2"]').trigger('click');

        QUnit.strictEqual(
            $('tbody tr').length,
            1,
            'Table contains one row on page 2'
        );

        $('a[data-page="5"]').trigger('click');

        QUnit.strictEqual(
            $('.ep-trayPageCount span').text(),
            '5',
            'Page 5 of table was selected'
        );

        $('a[data-page="9"]').trigger('click');

        QUnit.strictEqual(
            $('.ep-trayPageCount span').text(),
            '9',
            'Last page of table was selected'
        );

    });

});