/*global define, CKEDITOR, setTimeout*/
/*jslint regexp: true*/
define(['testsuite/qunit', 'jquery', 'ep/ui/editor', '$ready!'], function (QUnit, $) {
    'use strict';

    QUnit.module("ckeditor/plugins/epimage");

    var delay,
        editor = $('#uieditor_ckeditortestinstance');

    function cke_test(setfunction, testfunction) {
        CKEDITOR.instances.uieditor_ckeditortestinstance.setData('');
        $('.cke_button__epimage').trigger('click');
        setTimeout(function () {
            QUnit.equal($('.fileManagerDialog').is(':visible'), true, 'Filemanager opened');
            $('.fileManagerDialog').data('uiUiDialog').close();
            setfunction();
            setTimeout(function () {
                QUnit.equal($('.fileManagerDialog').is(':visible'), false, 'Filemanager closed');
                $('.cke_dialog_ui_button_ok span').trigger('click');
                setTimeout(function () {
                    var data = CKEDITOR.instances.uieditor_ckeditortestinstance.getData();
                    testfunction(data);
                    QUnit.start();
                }, 200);
            }, 200);
            delay = true;
        }, delay? 100 : 1000);
    }

    // instantiate CKE
    editor.uiEditor({
        'name' : 'ckeditortestinstance',
        'toolbar': 'Full'
    });

    setTimeout(function () {

        QUnit.asyncTest("basic image source test", function () {
            cke_test(function () {
                $('#' + $('.cke_required').filter('label:contains(URL)').attr('for')).val('foobar.png');
            }, function (data) {
                var expected = /<img alt="" src="foobar.png" \/>/;
                QUnit.ok(data.search(expected) > -1, 'image source is set');
            });
        });


        QUnit.asyncTest("alt attribute test", function () {
            cke_test(function () {
                $('#' + $('.cke_required').filter('label:contains(URL)').attr('for')).val('foobar.png');
                $('.cke_dialog_contents .cke_dialog_page_contents tbody:first').children('tr:eq(1)').find('input').val('look at this beautfiful foo');
            }, function (data) {
                var expected = /<img alt="look at this beautfiful foo" src="foobar.png" \/>/;
                QUnit.ok(data.search(expected) > -1, 'alt attribute set correctly');
            });
        });

        QUnit.asyncTest("title attribute test", function () {
            cke_test(function () {
                $('#' + $('.cke_required').filter('label:contains(URL)').attr('for')).val('foobar.png');
                $('.cke_dialog_contents .cke_dialog_page_contents tbody:first').children('tr:eq(2)').find('input').val('barfoo');
            }, function (data) {
                var expected = /<img alt="" src="foobar.png" title="barfoo" \/>/;
                QUnit.ok(data.search(expected) > -1, 'title attribute set correctly');
            });
        });

        QUnit.asyncTest("width & height attribute test", function () {
            cke_test(function () {
                $('#' + $('.cke_required').filter('label:contains(URL)').attr('for')).val('foobar.png');
                $('.cke_dialog_contents .cke_dialog_page_contents tbody:first').children('tr:eq(3)').find('input:eq(0)').val('500');
                $('.cke_dialog_contents .cke_dialog_page_contents tbody:first').children('tr:eq(3)').find('input:eq(1)').val('300');
            }, function (data) {
                var expected = /<img alt="" src="foobar.png" style="width: 500px; height: 300px; ?" \/>/;
                QUnit.ok(data.search(expected) > -1, 'width and height attribute set correctly');
            });
        });

        QUnit.asyncTest("border attribute test", function () {
            cke_test(function () {
                $('#' + $('.cke_required').filter('label:contains(URL)').attr('for')).val('foobar.png');
                $('.cke_dialog_contents .cke_dialog_page_contents tbody:first').children('tr:eq(3)').find('input:eq(2)').val('1');
            }, function (data) {
                var expected = /<img alt="" src="foobar.png" style="border-width: 1px; border-style: solid; ?" \/>/;
                QUnit.ok(data.search(expected) > -1, 'border attribute set correctly');
            });
        });

        QUnit.asyncTest("margin attribute test", function () {
            cke_test(function () {
                $('#' + $('.cke_required').filter('label:contains(URL)').attr('for')).val('foobar.png');
                $('.cke_dialog_contents .cke_dialog_page_contents tbody:first').children('tr:eq(3)').find('input:eq(3)').val('5');
                $('.cke_dialog_contents .cke_dialog_page_contents tbody:first').children('tr:eq(3)').find('input:eq(4)').val('10');
            }, function (data) {
                var expected = /<img alt="" src="foobar.png" style="margin: 10px 5px; ?" \/>/;
                QUnit.ok(data.search(expected) > -1, 'margin attribute set correctly');
            });
        });

        QUnit.asyncTest("align attribute test", function () {
            cke_test(function () {
                $('#' + $('.cke_required').filter('label:contains(URL)').attr('for')).val('foobar.png');
                $('.cke_dialog_contents .cke_dialog_page_contents tbody:first').children('tr:eq(3)').find('select')[0].selectedIndex = 2;
            }, function (data) {
                var expected = /<img alt="" src="foobar.png" style="float: right; ?" \/>/;
                QUnit.ok(data.search(expected) > -1, 'align attribute set correctly');
            });
        });

    }, 2000);
});