﻿use strict;
use Test::Simple tests => 4;
use DE_EPAGES::Core::API::Script qw( RunScript );
use DE_EPAGES::Object::API::Factory qw( SplitObjectPath JoinObjectPath );
use utf8;

sub Main {

    {
        use utf8;
        my $aPath = SplitObjectPath( "/Categories/Шнъ" );
        ok( 3 == scalar( @$aPath ), "scalar SplitObjectPath" );
        ok( 'Шнъ' eq $aPath->[2], "value with russian characters" );

        my $PathString = JoinObjectPath( $aPath );
        ok( "/Categories/\"Шнъ\"" eq $PathString, "JoinObjectPath 1" );
        ok( '""""/"/"/" "/,' eq JoinObjectPath( [ '"', '/', ' ', ',' ] ), "JoinObjectPath 2" );
    }
}


RunScript(Sub=>\&Main, Debug=>1);
