package DE_EPAGES::PriceMinister::t::pager;
use base DE_EPAGES::Database::API::Test;

use Test::More;
use strict;

use DE_EPAGES::Object::API::Factory qw ( LoadObjectByPath );
use DE_EPAGES::PriceMinister::API::Object::PagerPWSItems;
use DE_EPAGES::PriceMinister::API::Object::RemotePWS;

sub testPortalSite {
    my $self = shift;
    my ($PortalSite) = @_;

    note 'testing portal site '.$PortalSite->alias;

    my $RemotePWS = DE_EPAGES::PriceMinister::API::Object::RemotePWS->new(
        'PWSURL'  => $PortalSite->get('PWSURL'),
        'Logging' => $PortalSite->get('Portal')->get('Logging'),
    );

    my $Pager = DE_EPAGES::PriceMinister::API::Object::PagerPWSItems->new({
        'ObjectID'      => 1,
        'RemotePWS'     => $RemotePWS,
        'Page'          => 1,
        'Parameters' => {
            'PSIN'          => undef,
            'UPCEAN'        => undef,
            'ProductName'   => 'pack',
        },
    });

    my $Page  = $Pager->page;
    my $Items = $Page->{'Pager'}->{'Items'};
    cmp_ok( scalar @$Items, '>', 0, ( scalar @$Items ) . ' results found for PWS keyword search.' );
}

sub test {
    my $self = shift;

    my $Portal = LoadObjectByPath('/Portals/PriceMinister');
    $self->testPortalSite( $Portal->child($_) ) foreach qw( PriceMinister_fr_FR PriceMinister_fr_FR_Sandbox );
    done_testing();
}

__PACKAGE__->runScript;
