#========================================================================================
# package      DE_EPAGES::RemoteSearch::t::SearchReplicationToken
# state        private
#========================================================================================
package DE_EPAGES::RemoteSearch::t::SearchReplicationToken;
use base DE_EPAGES::Database::API::Test;

use DE_EPAGES::Database::API::Connection qw ( GetCurrentDBHandle );
use DE_EPAGES::RemoteSearch::API::Table::SearchReplicationToken qw (
    ExistsSearchReplicationToken
    GetAllPKeySearchReplicationTokens
    IncrementAndGetReplicationToken
);
use Test::More tests => 5;

use strict;

sub TestIncrementAndGetReplicationToken {
    my $self = shift;

    # this can fail, if we have other activity on the testsite... but should be fairly seldom
    my $Token1 = IncrementAndGetReplicationToken();
    my $Token2 = IncrementAndGetReplicationToken();

    is( $Token1 + 1, $Token2, 'Increment and get token' );
    is( scalar @{GetAllPKeySearchReplicationTokens()}, 1, 'automatic cleanup' );
}

sub TestIncrementAndGetReplicationTokenInTransaction {
    my $self = shift;

    GetCurrentDBHandle()->transaction( sub {
        # this can fail, if we have other activity on the testsite... but should be fairly seldom
        my $Token1 = IncrementAndGetReplicationToken();
        my $Token2 = IncrementAndGetReplicationToken();

        is( $Token1 + 1, $Token2, 'Increment and get token' );
        ok( ExistsSearchReplicationToken( $Token1 ), 'no automatic cleanup' );
        ok( ExistsSearchReplicationToken( $Token2 ), 'no automatic cleanup' );
    });
}

sub test {
    TestIncrementAndGetReplicationToken();
    TestIncrementAndGetReplicationTokenInTransaction();
}

__PACKAGE__->runScript;
